<?php

/**
 * INTEGRATION ARGUS WITH ECWID BY ARTHIS TECHNOLOGY
 *
 * @author Karina Loria Brenes <karina@arthiscr.com>
 * March 2022
 *
 * */

include_once './Config/Global.php';
include_once './Config/genericConn.php';
echo "Sincronización de Argus";

syncProducts();
exit();

/* Function to read all Products from Client API */
function syncProducts() {
    //insert date
   // insertLastSyncDatetime("Inicio");
    
    $BASE_DATOS = "COM_GuillermoCortes";
    $API_KEY = "yD5Kmak9aFtJpnNBHizrowwko5IXwRUV8SQEmoR8QjjHymjnR0dKd0Vbm3yiKKyZAz5SpiYiWs";
    $ID_BODEGA = "3"; /* obvio estos son parametros de ejemplo, deben cambiarse*/
 
    $ch = curl_init();
   
    /* aqui se define hacia el url o endpoint al que nos vamos a comunicar pasando los parametros*/
     $url = "https://arguscoreapi.grupoargus.co.cr:128/_API/Integraciones/" . $BASE_DATOS . "?apikey=" . $API_KEY . "&method=API_Get_ObtenerProductos_OnSKU&jparams={'@ps_NombreBaseDatos':'" . $BASE_DATOS . "','@pl_IdBodega':'" . $ID_BODEGA . "'}"; 
     
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json;charset=utf-8'));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    $data = curl_exec($ch);

    $response = json_decode($data);
    $productArray = json_decode(json_encode($response), true);
	// print_r($productArray);exit();
    //read each product
    foreach ($productArray as $item) {
        
        //find product in store
        $ecwidResponse = getProductsFromAPI($item['CodigoBarras']);
      
        //validate if product exist
        if ($ecwidResponse['total'] > 0) {//exist
            //update product
            echo 'El codigo ' . $item['CodigoBarras'] . ' listo para actualizar.<br>';

            //validate quantity 
            $status = true;
            $quantity = $item['Existencia'];
            if($item['Existencia'] <= 0){
                $status = false;
                $quantity = 0;
            }//end if
               //
            //set product info
            $product = array(
                'quantity' => $quantity,
                'enabled' =>$status,
                'price' => $item['PrecioVentaC_IVI'],
                'unlimited' => false
            );
         
            $response = updateProductToStore($ecwidResponse['items']['0']['id'], $product);
          
            echo $response['updateCount'];
           
        }//end if
        else {
            echo 'El codigo ' . $item['CodigoBarras'] . ' no existe.<br>';
        }//end if/else
    
        
    }//end foreach
 
    //insert date
//    insertLastSyncDatetime("Fin");
//    echo "Termina la sincronización";
}//end syncProducts

/* Connect ECWID API */

//function to call API to get Product by SKU
function getProductsFromAPI($sku) {

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS .'?sku='.$sku.'&sortBy=NAME_ASC&token='.API_TOKEN);
   // curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS . '?name=LACTYFERRIN&offset=' . $offset . '&sortBy=NAME_ASC&enabled=true&token=' . API_TOKEN);
 //   curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS .'?offset='.$offset.'&sortBy=NAME_ASC&token='.API_TOKEN);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json;charset=utf-8'));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    $data = curl_exec($ch);

    $response = json_decode($data);
    $productArray = json_decode(json_encode($response), true);

    return $productArray;
}

//end getProductsFromAPI

//function to call API to update Product by SKU $product,$sku
function updateProductToStore($sku, $product) {

    //set params
    $params = json_encode($product);

    //set header
    $headers = array(
        "Content-Type: application/json; charset=utf-8",
        "Content-Length: " . strlen($params),
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS . '/' . $sku . '?token=' . API_SECRET_TOKEN);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);

    $data = curl_exec($ch);

    var_dump($data);

    $response = json_decode($data);

    $responseArray = json_decode(json_encode($response), true);

    return $responseArray;
}//end updateProductToStore

//function to get last sync datetime
function getLastSyncDatetime(){
    /*DB Config*/
    $conn =  new genericConn();
    
     //get last datetime
    $query = "SELECT `idControlLog`, `nameControlLog`, `datetimeControlLog` "
            . "FROM `ControlLog` WHERE nameControlLog = 'Fin Sincronización de Productos' "
            . "order by datetimeControlLog desc limit 1";

    $result = $conn->querySQL($query);
  
    //read all clients 
    while($row = mysqli_fetch_array($result)){
        $currentRow = array(
            "idControlLog" => $row['idControlLog'], 
            "nameControlLog" => $row['nameControlLog'], 
            "datetimeControlLog" => $row['datetimeControlLog'], 
         );

    }//end while
   
    return $currentRow;
}//end getLastSyncDatetime

//function to get last sync datetime
function insertLastSyncDatetime($action){
    /*DB Config*/
    $conn =  new genericConn();
    
     //get last datetime
    $query = "INSERT INTO `ControlLog`(`nameControlLog`, `datetimeControlLog`) "
            . "VALUES ('".$action." Sincronización de Productos','".getCurrentDate()."')";

    $result = $conn->querySQL($query);
  
}//end getLastSyncDatetime


/************************FUNCTIONS***********************************/
//get current date format for database 
function getCurrentDate() {
    return date('Y-m-d H:i:s');
}//end getCurrentDate
