<?php

/**
 * INTEGRATION ARGUS WITH ECWID BY ARTHIS TECHNOLOGY
 *
 * @author Karina Loria Brenes <karina@arthiscr.com>
 * March 2022
 *
 * */

include_once './Config/Global.php';
include_once './Config/genericConn.php';
echo "Sincronización de Argus";

$products = getProductsFromAPI(0);
//print_r($products);exit();
foreach ($products['items'] as $item) {
    echo "<br>SKU: " .  $item['sku'];
}
exit();
syncProducts();
exit();

/*$products = $client->read('product.product', $ids, $fields);
print_r($products);
exit();*/
/* * *************SEND Products to API STORE************** */
//read each product from Odoo API
foreach ($products as $currentProduct) {
    //  print_r($currentProduct); 
    //get Product data from Ecwid API
    $ecwidResponse = getProductFromAPI($currentProduct['code']);

    //validate if product exist
    if ($ecwidResponse['total'] > 0) {//exist
        //update product
        echo 'El codigo ' . $currentProduct['code'] . ' listo para actualizar.<br>';

        //set product info
        $product = array(
            //'quantity' => 3,
            'name' => 'Access Pinline test6'
                //'price' => 13165.00,
        );

        $response = updateProductToStore('198913459', $product);
        echo $reponse['updateCount'];
        exit();
    }//end if
    else {
        echo 'El codigo ' . $currentProduct['code'] . ' no existe.<br>';
    }//end if/else
}//end foreach

exit();

/* Function to read all Products from Ecwid */

function syncProducts() {
    //insert date
    insertLastSyncDatetime("Inicio");
    
    //get last sync datetime
    $lastSync = getLastSyncDatetime();
    
    /* Odoo Config */
    //DB Credentials
    $url = "http://192.241.240.4:4030";
    $db = "db_demo_inv_v10";
    $username = "arthissync";
    $password = "AS4321$";


    $client = new OdooClient($url, $db, $username, $password);
    // $v = $client->version();

    $offset = 0;
    //loop for read all products
    do {//read all products
        //get 100 by 100 products
        $response = getProductsFromAPI($offset);

        //get total products
        $total = $response['total'];
        $products = $response['items'];

        //read each product to search and update
        foreach ($products as $currentProduct) {

            if (empty($currentProduct['combinations'])) {//without combinations
                //find product in Odoo
                $criteria = [
                    ['barcode', '=', $currentProduct['sku']],
                ];

                //get Products from API
                $ids = $client->search('product.product', $criteria, 0, 10);
                //var_dump($ids);exit();
                //set the product fields to read
                $fields = ['name', 'lst_price', 'active', 'qty_available', 'barcode', 'default_code','write_date'];

                $odooProducts = $client->read('product.product', $ids, $fields);
                $odooProduct = $odooProducts[0];
                //print_r($odooProduct);exit();
                //update product into Ecwid
                //set product info
                $product = array(
                    'quantity' => $odooProduct['qty_available'],
                    //  'name' => $odooProduct['name']
                    'price' => $odooProduct['lst_price'],
                    'write_date' => $odooProduct['write_date']
                );
                //validate if date is after last sync
                if($lastSync['datetimeControlLog'] < $odooProduct['write_date']){//update
                    $responseEcwid = updateProductToStore($currentProduct['id'], $product);

                    if ($responseEcwid['updateCount'] > 0) {//updated
                        echo 'Código ' . $currentProduct['sku'] . ' actualizado.<br>';
                    } else {//not updated
                        echo 'Código ' . $currentProduct['sku'] . ' NO actualizado.<br>';
                    }//end if/else
                }//end if
            } else {//with combinations
            
                //read each combination 
                foreach ($currentProduct['combinations'] as $currentCombination) {
                    
                    //find product in Odoo
                    $criteria = [
                        ['barcode', '=', $currentCombination['sku']],
                    ];

                    //get Products from API
                    $ids = $client->search('product.product', $criteria, 0, 10);
                   // var_dump($ids);exit();
                    //set the product fields to read
                    $fields = ['name', 'lst_price', 'active', 'qty_available', 'barcode', 'default_code','write_date'];

                    $odooProducts = $client->read('product.product', $ids, $fields);
                    $odooProduct = $odooProducts[0];
                  
                    //update product into Ecwid
                    //set product info
                    $product = array(
                        'quantity' => $odooProduct['qty_available'],
                        //  'name' => $odooProduct['name']
                        'price' => $odooProduct['lst_price'],
                        'write_date' => $odooProduct['write_date']
                    );
                    //validate if date is after last sync
                    if($lastSync['datetimeControlLog'] < $odooProduct['write_date']){//update
                        $responseEcwid = updateProductCombinationToStore($currentProduct['id'],$currentCombination['id'], $product);

                        if ($responseEcwid['updateCount'] > 0) {//updated
                            echo 'Código ' . $currentProduct['sku'] . ', combinación ' . $currentCombination['sku'] . ' actualizada.<br>';
                        } else {//not updated
                            echo 'Código ' . $currentProduct['sku'] . ' combinación ' . $currentCombination['sku'] . ' NO actualizada.<br>';
                        }//end if/else
                    }//end if
                }//end foreach
            }//end if/else 
        }//end foreach

        $offset += 100;
    } while ($offset < $total);

    //insert date
    insertLastSyncDatetime("Fin");
    echo "Termina la sincronización";
}

//end syncProducts

/* Connect ECWID API */

//function to call API to get Product by SKU
function getProductsFromAPI($offset) {

    $ch = curl_init();
   // curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS .'?sku=8429979461759&offset='.$offset.'&sortBy=NAME_ASC&enabled=true&token='.API_TOKEN);
   // curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS . '?name=LACTYFERRIN&offset=' . $offset . '&sortBy=NAME_ASC&enabled=true&token=' . API_TOKEN);
    curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS .'?offset='.$offset.'&sortBy=NAME_ASC&enabled=true&token='.API_TOKEN);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json;charset=utf-8'));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    $data = curl_exec($ch);
var_dump($data);
    $response = json_decode($data);
    $productArray = json_decode(json_encode($response), true);

    return $productArray;
}

//end getProductsFromAPI

//function to call API to update Product by SKU $product,$sku
function updateProductToStore($sku, $product) {

    //set params
    $params = json_encode($product);

    //set header
    $headers = array(
        "Content-Type: application/json; charset=utf-8",
        "Content-Length: " . strlen($params),
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS . '/' . $sku . '?token=' . API_SECRET_TOKEN);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);

    $data = curl_exec($ch);



    $response = json_decode($data);

    $responseArray = json_decode(json_encode($response), true);

    return $responseArray;
}//end updateProductToStore

//function to call API to update Product combination by SKU $product,$sku
function updateProductCombinationToStore($sku,$combinationID, $product) {

    //set params
    $params = json_encode($product);

    //set header
    $headers = array(
        "Content-Type: application/json; charset=utf-8",
        "Content-Length: " . strlen($params),
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, API_PATH . API_PATH_PRODUCTS . '/' . $sku . '/'.API_PATH_COMBINATIONS.'/'.$combinationID.'?token=' . API_SECRET_TOKEN);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);

    $data = curl_exec($ch);

    $response = json_decode($data);

    $responseArray = json_decode(json_encode($response), true);

    return $responseArray;
}//end updateProductToStore

//function to get last sync datetime
function getLastSyncDatetime(){
    /*DB Config*/
    $conn =  new genericConn();
    
     //get last datetime
    $query = "SELECT `idControlLog`, `nameControlLog`, `datetimeControlLog` "
            . "FROM `ControlLog` WHERE nameControlLog = 'Fin Sincronización de Productos' "
            . "order by datetimeControlLog desc limit 1";

    $result = $conn->querySQL($query);
  
    //read all clients 
    while($row = mysqli_fetch_array($result)){
        $currentRow = array(
            "idControlLog" => $row['idControlLog'], 
            "nameControlLog" => $row['nameControlLog'], 
            "datetimeControlLog" => $row['datetimeControlLog'], 
         );

    }//end while
   
    return $currentRow;
}//end getLastSyncDatetime

//function to get last sync datetime
function insertLastSyncDatetime($action){
    /*DB Config*/
    $conn =  new genericConn();
    
     //get last datetime
    $query = "INSERT INTO `ControlLog`(`nameControlLog`, `datetimeControlLog`) "
            . "VALUES ('".$action." Sincronización de Productos','".getCurrentDate()."')";

    $result = $conn->querySQL($query);
  
}//end getLastSyncDatetime


/************************FUNCTIONS***********************************/
//get current date format for database 
function getCurrentDate() {
    return date('Y-m-d H:i:s');
}//end getCurrentDate
